<template>
  <div>
    <div @click="openDialog">
      <slot></slot>
    </div>
    <a-modal v-model="isDialogActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeDialog">Back</b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">VIDEO</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <div v-for="(video, index) in videos" v-show="index === selectedIndex" :key="index" class="p-12 py-10">
          <video controls class="w-full" height="250">
            <source :src="video.bbsVideoUrl" type="video/mp4">
          </video>
        </div>
        <a-radio-group v-model="selectedIndex" button-style="solid">
          <a-radio-button v-for="(video, index) in videos" :key="video.bbsVideoUrl" :value="index">{{getTime(video.startingTime)}} - {{getTime(video.endingTime)}}</a-radio-button>
        </a-radio-group>
      </div>
      <div v-if="!isVideoFetching && videos.length === 0" class="pb-4">
        <a-empty></a-empty>
      </div>
    </a-modal>
  </div>
</template>

<script>
import { defineComponent } from '@nuxtjs/composition-api'
import moment from 'moment'
import TH1 from '~/components/shared/typography/H1'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton'
import usePersonVideo from '~/composables/usePersonVideo'

export default defineComponent({
  components: { BOutlineActionButton, TH1 },
  props: {
    passengerId: {
      type: String,
      required: true
    },
    cameraId: {
      type: String,
      required: true
    },
    startTime: {
      type: String,
      required: true
    },
    endTime: {
      type: String,
      required: true
    },
  },
  setup() {
    return { ...usePersonVideo() }
  },
  data() {
    return {
      selectedIndex: 0,
      isDialogActive: false,
    }
  },
  methods: {
    openDialog() {
      this.fetchVideos(this.passengerId, this.cameraId, this.startTime, this.endTime) 
      this.isDialogActive = true
    },
    closeDialog() {
      this.isDialogActive = false
    },
    getTime(isoDate) {
      return moment(isoDate).format('HH:mm')
    },
  },
})
</script>
